=== debian/changelog ===
scram (0.11.4-1) unstable; urgency=low

  * Initial Debian Package (Closes: #842766)

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Tue, 06 Dec 2016 11:27:56 +0100
