=== debian/changelog ===
scram (0.11.5-1) unstable; urgency=medium

  * Update to new 0.11.5 upstream release
  * Remove the patch of CMakeLists.txt
    and use options provided in the new release
  * Use the man page from the doc directly
    (this had a typo in the previous release)

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Wed, 14 Dec 2016 00:27:41 -0800
