=== debian/control ===
Source: scram
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olzhas Rakhimov <ol.rakhimov@gmail.com>
Build-Depends: debhelper (>= 10),
               cmake (>= 2.8.12),
               libxml++2.6-dev (>= 2.38.1),
               libboost-all-dev (>= 1.56.0),
               libgoogle-perftools-dev
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/scram.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/scram.git
Homepage: http://scram-pra.org

Package: scram
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Probabilistic Risk Analysis Tool
 A command line probabilistic risk analysis tool
 capable of performing static fault tree analysis,
 analysis with common cause failure models,
 probability calculations with importance analysis,
 and uncertainty analysis with Monte Carlo simulations.
