=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,8 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+		-DBUILD_SHARED_LIBS=OFF \
+		-DINSTALL_LIBS=OFF \
 		-DCMAKE_BUILD_TYPE=Release \
 		-DBUILD_GUI=OFF \
 		-DBUILD_TESTS=OFF
