## scram 0.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,14 +13,14 @@
 
 project(SCRAM)
 set(SCRAM_VERSION_MAJOR 0)  # Indicate major API change after 1.0.0
-set(SCRAM_VERSION_MINOR 11)  # New features and improvements.
-set(SCRAM_VERSION_MICRO 5)  # Bug fixes.
+set(SCRAM_VERSION_MINOR 14)  # New features and improvements.
+set(SCRAM_VERSION_MICRO 0)  # Bug fixes.
 
 ####################### Begin Options ###################
 
 option(BUILD_SHARED_LIBS OFF)
 
-option(INSTALL_LIBS "Install the generated libraries" ON)
+option(INSTALL_LIBS "Install the generated libraries" ${BUILD_SHARED_LIBS})
 
 # Linking of external libraries, such as BOOST.
 option(WITH_STATIC_LIBS "Try to link against static libraries" OFF)
@@ -31,6 +31,8 @@
 option(WITH_COVERAGE "Instrument for coverage analysis" OFF)
 option(WITH_PROFILE "Instrument for performance profiling" OFF)
 
+option(HAS_TANGO "The system provides the fall-back Tango icons" OFF)
+
 option(BUILD_GUI "Build the GUI front-end" ON)
 option(BUILD_TESTS "Build the tests" ON)
 
@@ -41,34 +43,48 @@
 ####################### Begin compiler configurations ###################
 
 # Default to C++14.
-include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG("-std=c++1y" COMPILER_SUPPORTS_CXX14)
-if(NOT COMPILER_SUPPORTS_CXX14)
-  message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support.")
-endif()
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y")
+if(CMAKE_VERSION VERSION_LESS 3.1)
+  include(CheckCXXCompilerFlag)
+  CHECK_CXX_COMPILER_FLAG("-std=c++1y" COMPILER_SUPPORTS_CXX14)
+  if(NOT COMPILER_SUPPORTS_CXX14)
+    message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support.")
+  endif()
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y")
+else()
+  set(CMAKE_CXX_STANDARD 14)
+  set(CMAKE_CXX_STANDARD_REQUIRED ON)
+  set(CMAKE_CXX_EXTENSIONS OFF)
+endif()
+
+function(CHECK_COMPILER_VERSION MIN_VERSION)
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS MIN_VERSION)
+    message(FATAL_ERROR "${CMAKE_CXX_COMPILER_ID} Compiler version too old. Required minimum version: ${MIN_VERSION}")
+  endif()
+endfunction()
 
 set(CMAKE_CXX_FLAGS_DEBUG
   "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor -Wno-missing-field-initializers")
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wpedantic")
+  CHECK_COMPILER_VERSION("4.9")  # TODO: Wpedantic with gcc 4.9 errors with default arg lambdas.
   if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5)
-    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wsuggest-override")
-  endif()
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6)
-    # TODO: Boost sign bit shift fails to compile on GCC 6.1
-    add_definitions("-fpermissive")
-  endif()
-
-elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
-       "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
+    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wpedantic")
+  endif()
+
+elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+  CHECK_COMPILER_VERSION("3.6")
   set(CMAKE_CXX_FLAGS_DEBUG
     "${CMAKE_CXX_FLAGS_DEBUG} -Wno-missing-braces -Wshadow -Wunused-exception-parameter")
 
-elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
-  # TODO: Bug in Intel compiler with multi-initialization with auto.
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=3373")
+elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
+  CHECK_COMPILER_VERSION("6.1")
+
+elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
+  CHECK_COMPILER_VERSION("17.0.1")
+  # TODO: CMAKE_CXX_STANDARD has no effect on icc.
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+  # TODO: Bug in Intel compiler with multi-initialization with auto and final-is-not-override.
+  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=3373,1125")
 endif()
 
 if(WIN32)
@@ -104,10 +120,10 @@
   set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/bin")
 endif()
 if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
-  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib")
+  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib/scram")
 endif()
 if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
-  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib")
+  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${SCRAM_BINARY_DIR}/lib/scram")
 endif()
 
 set(SCRAM_EXECUTABLE_DIR "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
@@ -121,7 +137,7 @@
 set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 
 if(INSTALL_LIBS)
-  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/scram")
 endif()
 
 # Add the automatically determined parts of the RPATH,
@@ -161,7 +177,7 @@
 # Include the boost header files and the program_options library.
 # Please be sure to use Boost rather than BOOST.
 # Capitalization matters on some platforms.
-set(BOOST_MIN_VERSION "1.56.0")
+set(BOOST_MIN_VERSION "1.58.0")
 set(Boost_USE_STATIC_LIBS ${WITH_STATIC_LIBS})
 set(Boost_USE_STATIC_RUNTIME ${WITH_STATIC_LIBS})
 
@@ -196,29 +212,16 @@
 set(LIBS ${LIBS} ${Boost_DATE_TIME_LIBRARY})
 message(STATUS "    Boost Date-Time location: ${Boost_DATE_TIME_LIBRARY}")
 
-if(BUILD_GUI)
-  # Find the QtWidgets library.
-  if(APPLE)
-    # Qt5 with Homebrew.
-    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "/usr/local/opt/qt5")
-  endif()
-  find_package(Qt5Widgets REQUIRED)
-  if(Qt5Widgets_FOUND)
-    message(STATUS "Found Qt5")
-    message(STATUS "Qt5 Version: ${Qt5Widgets_VERSION_STRING}")
-  endif()
-endif()
-
 ########################## End of find libraries ########################
 
 ########################## Begin includes ###############################
 
 # Include all the discovered system directories.
 include_directories(SYSTEM "${Boost_INCLUDE_DIR}")
-include_directories(SYSTEM "${LIBXML2_INCLUDE_DIR}")  # TODO: libxml++ dependency.
 include_directories(SYSTEM "${LibXML++_INCLUDE_DIR}")
 include_directories(SYSTEM "${LibXML++Config_INCLUDE_DIR}")
-include_directories(SYSTEM ${Glibmm_INCLUDE_DIRS})  # TODO: libxml++ dependency.
+include_directories(SYSTEM ${Glibmm_INCLUDE_DIRS})
+include_directories(SYSTEM "${LIBXML2_INCLUDE_DIR}")
 
 include_directories("${PROJECT_SOURCE_DIR}")  # Include the core headers via "src".
 
@@ -254,22 +257,35 @@
 if(PACKAGE)
   if(WIN32)
     set(CPACK_GENERATOR "NSIS")
-    # TODO: Find a way to programmatically detect shared libraries and add to installation.
+    # set(CPACK_PACKAGE_ICON "${PROJECT_SOURCE_DIR}\\\\gui\\\\images\\\\scram_logo.bmp")
+    set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\scram-gui.exe")
+    set(CPACK_NSIS_MODIFY_PATH ON)
+    set(CPACK_NSIS_HELP_LINK "https://scram-pra.org")
+    set(CPACK_NSIS_URL_INFO_ABOUT "https://scram-pra.org")
+    set(CPACK_NSIS_CONTACT "scram-users@googlegroups.com")
+    set(CPACK_PACKAGE_EXECUTABLES "scram-gui" "SCRAM")
+    set(CPACK_CREATE_DESKTOP_LINKS "scram-gui")
+    set(CPACK_COMPONENT_GUI_REQUIRED ON)
     # The following configuration assumes MinGW64 is setup specifically for this project.
+    # Moreover, the Qt5 libs and plugins must be linked staticly,
+    # so there's no headache with implicit (undiscoverable) dependencies.
     get_filename_component(MINGW_DLL_DIR "${CMAKE_CXX_COMPILER}" PATH)
     message(STATUS "MinGW bin location: ${MINGW_DLL_DIR}")
-    file(GLOB all_libs "${MINGW_DLL_DIR}/lib*.dll")
+    include(GetPrerequisites)
+    get_prerequisites("${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/scram.exe"
+      SCRAM_ALL_PREREQUISITES 1 1 "" "")
+    message(STATUS "SCRAM dependency libs:\n${SCRAM_ALL_PREREQUISITES}")
+    foreach(item ${SCRAM_ALL_PREREQUISITES})
+      string(REGEX MATCH "scram" is_scram "${item}")
+      if(NOT is_scram)
+        gp_resolve_item("${MINGW_DLL_DIR}" "${item}" "" "" item)
+        list(APPEND SCRAM_PREREQUISITES ${item})
+      endif()
+    endforeach()
+    message(STATUS "SCRAM dependency libs resolution:\n${SCRAM_PREREQUISITES}")
+
     install(FILES
-      ${all_libs}
-      ${MINGW_DLL_DIR}/zlib1.dll
-      DESTINATION bin COMPONENT libraries
-    )
-
-    # Qt Libraries
-    install(FILES
-      ${MINGW_DLL_DIR}/Qt5Core.dll
-      ${MINGW_DLL_DIR}/Qt5Gui.dll
-      ${MINGW_DLL_DIR}/Qt5Widgets.dll
+      ${SCRAM_PREREQUISITES}
       DESTINATION bin COMPONENT libraries
     )
   endif()
@@ -282,6 +298,8 @@
 set(CPACK_PACKAGE_VERSION_PATCH "${SCRAM_VERSION_MICRO}")
 set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
 
+set(CPACK_STRIP_FILES ON)
+
 set(CPACK_COMPONENTS_ALL scram libraries gui examples)
 set(CPACK_COMPONENT_SCRAM_REQUIRED ON)
 set(CPACK_COMPONENT_LIBRARIES_REQUIRED ON)
