=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,13 +13,11 @@
 
 set(LIB_LINK_FLAGS "")
 if(WITH_COVERAGE)
-  add_definitions("--coverage")
-  set(LIB_LINK_FLAGS "--coverage")
-  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LIB_LINK_FLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
 endif()
 
 if(WITH_PROFILE)
-  add_definitions("-pg")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
 endif()
 
 set(SCRAM_CORE_SRC
@@ -31,19 +29,21 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/random.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/settings.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/config.cc"
-  "${CMAKE_CURRENT_SOURCE_DIR}/cycle.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/element.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/expression.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/parameter.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/expression/conditional.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/expression/constant.cc"
-  "${CMAKE_CURRENT_SOURCE_DIR}/expression/arithmetic.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/expression/numerical.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/expression/exponential.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/expression/random_deviate.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/expression/test_event.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/event.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/ccf_group.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/fault_tree.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/event_tree.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/model.cc"
-  "${CMAKE_CURRENT_SOURCE_DIR}/boolean_graph.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/pdag.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/preprocessor.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/mocus.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bdd.cc"
@@ -53,30 +53,26 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/probability_analysis.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/importance_analysis.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/uncertainty_analysis.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/event_tree_analysis.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/reporter.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/serialization.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/initializer.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/risk_analysis.cc"
   )
 add_library(scramcore ${SCRAM_CORE_SRC})
 
 if(INSTALL_LIBS)
-  set_target_properties(scramcore
-    PROPERTIES
-    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
-    INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib"
-    LINK_FLAGS "${LIB_LINK_FLAGS}"
-    )
   if(WIN32)
+    install(TARGETS scramcore RUNTIME DESTINATION bin COMPONENT scram)
+  else()
+    set_target_properties(scramcore
+      PROPERTIES
+      INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib/scram"
+      INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/scram"
+      )
     install(
       TARGETS scramcore
-      RUNTIME DESTINATION bin COMPONENT scram
-      LIBRARY DESTINATION lib COMPONENT scram
-      ARCHIVE DESTINATION lib COMPONENT scram
-      )
-  else()
-    install(
-      TARGETS scramcore
-      DESTINATION lib
+      DESTINATION lib/scram
       COMPONENT scram
       )
   endif()
