=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,10 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/expression_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/ccf_group_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/fault_tree_tests.cc"
-  "${CMAKE_CURRENT_SOURCE_DIR}/boolean_graph_tests.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/pdag_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/initializer_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/risk_analysis_tests.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/serialization_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_core_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_two_train_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_lift_tests.cc"
@@ -41,6 +42,9 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_baobab1_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_baobab2_tests.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/bench_CEA9601_tests.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/bench_hipps_tests.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/bench_attack.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/bench_gas_leak.cc"
   "${CMAKE_CURRENT_SOURCE_DIR}/performance_tests.cc"
   )
