=== debian/changelog ===
scram (0.14.0-1) unstable; urgency=medium

  * New upstream 0.14.0
  * Configure GUI dependencies (Qt5)
  * Boost min version bump to 1.58
  * Generate man page with help2man (manually, ironically :)
  * Standards version bump to 4.0.1
  * Bump the copyright year to 2017
  * New 'scram-gui' binary
  * Configure the packaging for multi-binary (separate & explicit install)
  * Use 'dh-exec' to rename 'scram.sh' to 'scram' upon installation
  * Override 'dh_install' to warn missing installations

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Mon, 31 Jul 2017 19:38:57 -0700
